$rownum (and possibly other functions) do not work on virtual fields

2018-07-17 11:30 AM - Giovanni Manghi

Status: Closed

Priority: Normal

Assignee:

Category: Field calculator

Affected QGIS version:3.3(master) Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: wontfix

Crashes QGIS or corrupts data:No Copied to github as #: 27259

Description

It always return "0".

Another example is "count", which returns always NULL.

Tested on LTR and master.

On non virtual fields are ok.

History

#1 - 2018-07-17 11:53 AM - Luigi Pirelli

confirmed on master an 2.18 LTR

#2 - 2018-07-17 11:57 AM - Luigi Pirelli

rownumber is filled here 

https://github.com/qgis/QGIS/blob/master/src/app/qgsfieldcalculator.cpp#L274

but completly skipped here

https://github.com/qgis/QGIS/blob/master/src/app/qgsfieldcalculator.cpp#L197 in case of virtualfields

probably a simple if reorganization would solve... investigating more

#3 - 2018-07-20 03:24 AM - Nyall Dawson

- Resolution set to wontfix

- Status changed from Open to Closed

It's deliberately not exposed here, because it has no meaning outside of the field calculator (since virtual fields are "global" for a layer, yet the layer may be

opened in two different attribute table dialogs both with different sort orders). Use $id instead.

2024-03-20 1/1

https://github.com/qgis/QGIS/blob/master/src/app/qgsfieldcalculator.cpp#L274
https://github.com/qgis/QGIS/blob/master/src/app/qgsfieldcalculator.cpp#L197

